diff -uNrd ircd-hybrid-6.0/src/channel.c ircd-pi1.0a/src/channel.c
--- ircd-hybrid-6.0/src/channel.c	Sun Nov 26 23:11:49 2000
+++ ircd-pi1.0a/src/channel.c	Thu May 23 00:22:22 2002
@@ -2334,26 +2645,49 @@
     }
 #endif
 
-  if ( (ban_or_exception = is_banned(sptr, chptr)) == CHFL_BAN)
-    return (ERR_BANNEDFROMCHAN);
+  if((ban_or_exception = is_banned(sptr, chptr)) == CHFL_BAN)
+    return ERR_BANNEDFROMCHAN;
   else
     *flags |= ban_or_exception; /* Mark this client as "charmed" */
 
-  if (chptr->mode.mode & MODE_INVITEONLY)
+  if(chptr->mode.mode & MODE_INVITEONLY)
     {
-      for (lp = sptr->user->invited; lp; lp = lp->next)
-        if (lp->value.chptr == chptr)
+      for(lp = sptr->user->invited; lp; lp = lp->next)
+        if(lp->value.chptr == chptr)
           break;
-      if (!lp)
-        return (ERR_INVITEONLYCHAN);
+      if(!lp)
+        return ERR_INVITEONLYCHAN;
     }
 
-  if (*chptr->mode.key && (BadPtr(key) || irccmp(chptr->mode.key, key)))
-    return (ERR_BADCHANNELKEY);
+  if(*chptr->mode.key && (BadPtr(key) || strcmp(chptr->mode.key, key)))
+    return ERR_BADCHANNELKEY;
 
-  if (chptr->mode.limit && chptr->users >= chptr->mode.limit)
-    return (ERR_CHANNELISFULL);
+  if(chptr->mode.limit && chptr->users >= chptr->mode.limit)
+    return ERR_CHANNELISFULL;
 
+#ifdef HAVE_SSL
+  if(MyConnect(sptr) && IsSSLChannel(chptr))
+    {
+      if(!IsSSL(sptr) || !is_ssl_channel(chptr))
+        {
+          if(IsSSLOnlyChannel(chptr))
+            return ERR_NEEDSSL;
+          
+          sendto_realops_flags(FLAGS_DEBUG,
+                               "Local JOIN for channel %s, nick %s breaks SSL mode.",
+                               chptr->chname, sptr->name);
+          
+          ClearSSLChannel(chptr);
+          sendto_channel_butserv(chptr, sptr,
+                                 ":%s MODE %s -z",
+                                 me.name, chptr->chname);
+          sendto_match_servs(chptr, sptr,
+                             ":%s MODE %s -z",
+                             me.name, chptr->chname);
+        }
+    }
+#endif
+  
   return 0;
 }
 
@@ -2971,20 +3305,19 @@
   int   successful_join_count = 0; /* Number of channels successfully joined */
 #endif
   
-  if (!(sptr->user))
+  if(!(sptr->user))
     {
       /* something is *fucked* - bail */
       return 0;
     }
 
-  if (parc < 2 || *parv[1] == '\0')
+  if(parc < 2 || *parv[1] == '\0')
     {
       sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "JOIN");
       return 0;
     }
 
-
 #ifdef NEED_SPLITCODE
 
   /* Check to see if the timer has timed out, and if so, see if
@@ -3056,7 +3389,7 @@
       (void)strncat(jbuf, name, sizeof(jbuf) - i - 1);
       i += strlen(name)+1;
     }
-  /*    (void)strcpy(parv[1], jbuf);*/
+/*    (void)strcpy(parv[1], jbuf);  whats this? */
 
   p = NULL;
   if (parv[2])
@@ -3125,25 +3458,25 @@
           continue;
         }
       
-      if (MyConnect(sptr))
+      if(MyConnect(sptr))
         {
           /*
           ** local client is first to enter previously nonexistent
           ** channel so make them (rightfully) the Channel
           ** Operator.
           */
-           /*     flags = (ChannelExists(name)) ? 0 : CHFL_CHANOP; */
+          /*     flags = (ChannelExists(name)) ? 0 : CHFL_CHANOP; */
 
           /* To save a redundant hash table lookup later on */
            
-           if((chptr = hash_find_channel(name, NullChn)))
-             flags = 0;
-           else
-             flags = CHFL_CHANOP;
-
-           /* if its not a local channel, or isn't an oper
-            * and server has been split
-            */
+          if((chptr = hash_find_channel(name, NullChn)))
+            flags = 0;
+          else
+            flags = CHFL_CHANOP;
+          
+          /* if its not a local channel, or isn't an oper
+           * and server has been split
+           */
 
 #ifdef NO_CHANOPS_WHEN_SPLIT
           if((*name != '&') && !IsAnOper(sptr) && server_was_split)
@@ -3152,12 +3485,12 @@
 
               if(!IsRestricted(sptr) && (flags & CHFL_CHANOP))
                 sendto_one(sptr,":%s NOTICE %s :*** Notice -- Due to a network split, you can not obtain channel operator status in a new channel at this time.",
-                       me.name,
-                       sptr->name);
+                           me.name,
+                          sptr->name);
             }
 #endif
 
-          if ((sptr->user->joined >= MAXCHANNELSPERUSER) &&
+          if((sptr->user->joined >= MAXCHANNELSPERUSER) &&
              (!IsAnOper(sptr) || (sptr->user->joined >= MAXCHANNELSPERUSER*3)))
             {
               sendto_one(sptr, form_str(ERR_TOOMANYCHANNELS),
@@ -3173,7 +3506,7 @@
 #ifdef ANTI_SPAMBOT       /* Dianora */
           if(flags == 0)        /* if channel doesn't exist, don't penalize */
             successful_join_count++;
-          if( SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
+          if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
             { 
               /* Its already known as a possible spambot */
  
@@ -3181,20 +3514,20 @@
                 sptr->oper_warn_count_down--;
               else
                 sptr->oper_warn_count_down = 0;
- 
+
               if(sptr->oper_warn_count_down == 0)
                 {
                   sendto_ops_flags(FLAGS_BOTS,
-                    "User %s (%s@%s) trying to join %s is a possible spambot",
-                             sptr->name,
-                             sptr->username,
-                             sptr->host,
-                             name);     
+                                   "User %s (%s@%s) trying to join %s is a possible spambot",
+                                   sptr->name,
+                                   sptr->username,
+                                   sptr->host,
+                                   name);
                   sptr->oper_warn_count_down = OPER_SPAM_COUNTDOWN;
                 }
 #ifndef ANTI_SPAMBOT_WARN_ONLY
               return 0; /* Don't actually JOIN anything, but don't let
-                           spambot know that */
+                          spambot know that */
 #endif
             }
 #endif
@@ -3205,7 +3538,7 @@
           ** complain for remote JOINs to existing channels
           ** (they should be SJOINs) -orabidoo
           */
-          if (!ChannelExists(name))
+          if(!ChannelExists(name))
             ts_warn("User on %s remotely JOINing new channel", 
                     sptr->user->server);
         }
@@ -3213,13 +3546,13 @@
 #if defined(NO_JOIN_ON_SPLIT)
       if(server_was_split && (*name != '&'))
         {
-          if( chptr )   /* The channel existed, so I can't join it */
+          if(chptr)   /* The channel existed, so I can't join it */
             {
-              if (IsMember(sptr, chptr)) /* already a member, ignore this */
+              if(IsMember(sptr, chptr)) /* already a member, ignore this */
                 continue;
 
               /* allow local joins to this channel */
-              if( (chptr->users == 0) && !IsAnOper(sptr) )
+              if((chptr->users == 0) && !IsAnOper(sptr))
                 {
                   sendto_one(sptr, form_str(ERR_UNAVAILRESOURCE),
                              me.name, parv[0], name);
@@ -3231,17 +3564,17 @@
         }
       else
 #endif
-      if(!chptr)        /* If I already have a chptr, no point doing this */
-        chptr = get_channel(sptr, name, CREATE);
+        if(!chptr)        /* If I already have a chptr, no point doing this */
+          chptr = get_channel(sptr, name, CREATE);
 
       if(chptr)
         {
-          if (IsMember(sptr, chptr))    /* already a member, ignore this */
+          if(IsMember(sptr, chptr))    /* already a member, ignore this */
             continue;
         }
       else
         {
-           sendto_one(sptr, form_str(ERR_UNAVAILRESOURCE),
+          sendto_one(sptr, form_str(ERR_UNAVAILRESOURCE),
                       me.name, parv[0], name);
 #ifdef ANTI_SPAMBOT
           if(successful_join_count > 0)
@@ -3256,16 +3589,19 @@
        * flags will have CHFL_EXCEPTION set
        */
 
-      if (MyConnect(sptr) && (i = can_join(sptr, chptr, key, &flags)))
+      if(MyConnect(sptr) && !IsEnforce(sptr) && (i = can_join(sptr, chptr, key, &flags)))
         {
           sendto_one(sptr,
-                    form_str(i), me.name, parv[0], name);
+                     form_str(i), me.name, parv[0], name);
 #ifdef ANTI_SPAMBOT
           if(successful_join_count > 0)
             successful_join_count--;
 #endif
           continue;
         }
+      if(can_join(sptr, chptr, key, &flags))
+         sendto_realops("Enforced join to %s from %s",     
+                         chptr->chname, sptr->name);
 
       /*
       **  Complete user entry to the new channel (if any)
@@ -3273,20 +3609,17 @@
 
 #ifdef NO_CHANOPS_WHEN_SPLIT
       if(allow_op)
-        {
-          add_user_to_channel(chptr, sptr, flags);
-        }
+        add_user_to_channel(chptr, sptr, flags);
       else
-        {
-          add_user_to_channel(chptr, sptr, flags & CHFL_EXCEPTION);
-        }
+        add_user_to_channel(chptr, sptr, flags & CHFL_EXCEPTION);
 #else
       add_user_to_channel(chptr, sptr, flags);
 #endif
+      
       /*
       **  Set timestamp if appropriate, and propagate
       */
-      if (MyClient(sptr) && (flags & CHFL_CHANOP) )
+      if(MyClient(sptr) && (flags & CHFL_CHANOP))
         {
           chptr->channelts = CurrentTime;
 #ifdef NO_CHANOPS_WHEN_SPLIT
@@ -3294,54 +3627,70 @@
             {
               sendto_match_servs(chptr, cptr,
                                  ":%s SJOIN %lu %s + :@%s", me.name,
-                                 chptr->channelts, name, parv[0]);
-
+                                 chptr->channelts, chptr->chname, parv[0]);
             }                                
           else
             sendto_match_servs(chptr, cptr,
                                ":%s SJOIN %lu %s + :%s", me.name,
-                               chptr->channelts, name, parv[0]);
+                               chptr->channelts, chptr->chname, parv[0]);
 #else
           sendto_match_servs(chptr, cptr,
                              ":%s SJOIN %lu %s + :@%s", me.name,
-                             chptr->channelts, name, parv[0]);
+                             chptr->channelts, chptr->chname, parv[0]);
 #endif
         }
-      else if (MyClient(sptr))
+      else if(MyClient(sptr))
         {
           sendto_match_servs(chptr, cptr,
                              ":%s SJOIN %lu %s + :%s", me.name,
-                             chptr->channelts, name, parv[0]);
+                             chptr->channelts, chptr->chname, parv[0]);
         }
       else
         sendto_match_servs(chptr, cptr, ":%s JOIN :%s", parv[0],
-                           name);
+                            chptr->chname);
 
       /*
       ** notify all other users on the new channel
       */
       sendto_channel_butserv(chptr, sptr, ":%s JOIN :%s",
-                             parv[0], name);
-
-      if (MyClient(sptr))
+                             parv[0], chptr->chname);
+          
+      if(MyClient(sptr))
         {
-          if( flags & CHFL_CHANOP )
+          if(flags & CHFL_CHANOP)
             {
               chptr->mode.mode |= MODE_TOPICLIMIT;
               chptr->mode.mode |= MODE_NOPRIVMSGS;
-
-              sendto_channel_butserv(chptr, sptr,
-                                 ":%s MODE %s +nt",
-                                 me.name, chptr->chname);
-
-              sendto_match_servs(chptr, sptr, 
-                                 ":%s MODE %s +nt",
-                                 me.name, chptr->chname);
+#ifdef HAVE_SSL
+              if(IsSSLUmode(sptr))
+                {
+                  sendto_realops_flags(FLAGS_DEBUG,
+                                       "Local channel creation for channel %s, nick %s initiated into SSL mode.",
+                                       chptr->chname, sptr->name);
+                  
+                  SetSSLChannel(chptr);
+                  sendto_channel_butserv(chptr, sptr,
+                                         ":%s MODE %s +ntz",
+                                       me.name, chptr->chname);
+                  sendto_match_servs(chptr, sptr, 
+                                     ":%s MODE %s +ntz",
+                                     me.name, chptr->chname);
+                }
+              else
+#endif              
+                {
+                  sendto_channel_butserv(chptr, sptr,
+                                         ":%s MODE %s +nt",
+                                         me.name, chptr->chname);
+                  sendto_match_servs(chptr, sptr, 
+                                     ":%s MODE %s +nt",
+                                     me.name, chptr->chname);
+                }
             }
 
           del_invite(sptr, chptr);
-
-          if (chptr->topic[0] != '\0')
+  
+          if(chptr->topic[0] != '\0')
             {
               sendto_one(sptr, form_str(RPL_TOPIC), me.name,
                          parv[0], name, chptr->topic);
@@ -3352,8 +3701,9 @@
                          chptr->topic_time);
 #endif
             }
+
           parv[1] = name;
-          (void)m_names(cptr, sptr, 2, parv);
+          m_names(cptr, sptr, 2, parv);
         }
     }
 
@@ -3454,6 +3804,25 @@
       sendto_channel_butserv(chptr, sptr, PartFmt, parv[0], name);
       remove_user_from_channel(sptr, chptr, 0);
       name = strtoken(&p, (char *)NULL, ",");
+      
+#ifdef HAVE_SSL
+      if(!IsSSLChannel(chptr))
+        {
+          if(is_ssl_channel(chptr))
+             {
+               sendto_realops_flags(FLAGS_DEBUG, "PART from channel %s by %s puts channel into SSL mode.",
+                                    chptr->chname, sptr->name);
+               
+               SetSSLChannel(chptr);
+               sendto_channel_butserv(chptr, sptr,
+                                      ":%s MODE %s +z",
+                                      me.name, chptr->chname);
+               sendto_match_servs(chptr, sptr,
+                                  ":%s MODE %s +z",
+                                  me.name, chptr->chname);
+             }
+        }
+#endif
     }
   return 0;
 }
@@ -3492,6 +3861,7 @@
   char  *name;
   char  *p = (char *)NULL;
   char  *user;
+  int   enforced = 0;
 
   if (parc < 3 || *parv[1] == '\0')
     {
@@ -3530,7 +3900,7 @@
     { 
       /* was a user, not a server, and user isn't seen as a chanop here */
       
-      if(MyConnect(sptr))
+      if(MyConnect(sptr) && !IsEnforce(sptr))
         {
           /* user on _my_ server, with no chanops.. so go away */
           
@@ -3539,7 +3909,7 @@
           return(0);
         }
 
-      if(chptr->channelts == 0)
+      if((chptr->channelts == 0) && !IsEnforce(sptr))
         {
           /* If its a TS 0 channel, do it the old way */
           
@@ -3548,6 +3918,8 @@
           return(0);
         }
 
+      enforced = 1;
+
       /* Its a user doing a kick, but is not showing as chanop locally
        * its also not a user ON -my- server, and the channel has a TS.
        * There are two cases we can get to this point then...
@@ -3596,24 +3968,58 @@
 
   if (IsMember(who, chptr))
     {
+      if(enforced)
+      {
+        sendto_realops("Enforced kick for %s on %s from %s (%s@%s)",
+                       parv[2], chptr->chname, sptr->name, sptr->username, sptr->host);
+
+        if(IsServer(cptr))        
+          sendto_channel_butserv(chptr, sptr,
+                                 ":%s KICK %s %s :%s", sptr->servptr->name,
+                                 name, who->name, comment);
+        else
+          sendto_channel_butserv(chptr, sptr,
+                                 ":%s KICK %s %s :%s", me.name,
+                                 name, who->name, comment);
+      }
+      else
+      {
+
 #ifdef HIDE_OPS
-      sendto_channel_chanops_butserv(chptr, sptr,
-                             ":%s KICK %s %s :%s", parv[0],
-                             name, who->name, comment);
-      sendto_channel_non_chanops_butserv(chptr, sptr,
-                             ":%s KICK %s %s :%s", NETWORK_NAME,
-                             name, who->name, comment);
+        sendto_channel_chanops_butserv(chptr, sptr,
+                                       ":%s KICK %s %s :%s", parv[0],
+                                       name, who->name, comment);
+        sendto_channel_non_chanops_butserv(chptr, sptr,
+                                           ":%s KICK %s %s :%s", NETWORK_NAME,
+                                           name, who->name, comment);
 
 #else
-      sendto_channel_butserv(chptr, sptr,
-                             ":%s KICK %s %s :%s", parv[0],
-                             name, who->name, comment);
+        sendto_channel_butserv(chptr, sptr,
+                               ":%s KICK %s %s :%s", parv[0],
+                               name, who->name, comment);
 #endif
+      }
       sendto_match_servs(chptr, cptr,
                          ":%s KICK %s %s :%s",
                          parv[0], name,
                          who->name, comment);
       remove_user_from_channel(who, chptr, 1);
+#ifdef HAVE_SSL
+      if(!IsSSLChannel(chptr) && is_ssl_channel(chptr))
+        {
+          sendto_realops_flags(FLAGS_DEBUG, "KICK for %s puts channel %s into SSL mode",
+                               sptr->name, chptr->chname);
+          
+          SetSSLChannel(chptr);
+          sendto_channel_butserv(chptr, sptr,
+                                 ":%s MODE %s +z",
+                                 me.name, chptr->chname);
+          sendto_match_servs(chptr, sptr,
+                             ":%s MODE %s +z",
+                             me.name, chptr->chname);
+          
+        }
+#endif      
     }
   else
     sendto_one(sptr, form_str(ERR_USERNOTINCHANNEL),
@@ -3791,6 +4197,7 @@
 {
   struct Channel *chptr = NullChn;
   char  *topic = (char *)NULL, *name, *p = (char *)NULL;
+  int enforced = 0;
   
   if (parc < 2)
     {
@@ -3818,7 +4225,11 @@
           return 0;
         }
 
-      if (!IsMember(sptr, chptr))
+      /* topic is enforced if user is +e and not chanop or not member and chan is +t */
+      enforced = ((chptr->mode.mode & MODE_TOPICLIMIT) && !IsServer(sptr) &&
+                  (!IsMember(sptr, chptr) || !is_chan_op(sptr, chptr)) && (IsServer(cptr) || IsEnforce(sptr)));
+        
+      if (!IsMember(sptr, chptr) && !enforced)
         {
           sendto_one(sptr, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
               name);
@@ -3827,11 +4238,14 @@
 
       if (parc > 2) /* setting topic */
         topic = parv[2];
+      else
+        enforced = 0;
+
 
       if(topic) /* a little extra paranoia never hurt */
         {
           if ((chptr->mode.mode & MODE_TOPICLIMIT) == 0 ||
-               is_chan_op(sptr, chptr))
+               is_chan_op(sptr, chptr) || enforced || IsServer(cptr))
             {
               /* setting a topic */
               /*
@@ -3847,15 +4261,24 @@
               chptr->topic_time = CurrentTime;
 #endif
               sendto_match_servs(chptr, cptr,":%s TOPIC %s :%s",
-                                 parv[0], chptr->chname,
+                                 sptr->name, chptr->chname,
                                  chptr->topic);
-              sendto_channel_butserv(chptr, sptr, ":%s TOPIC %s :%s",
-                                     parv[0],
-                                     chptr->chname, chptr->topic);
+              
+              if(enforced && sptr->servptr)
+                sendto_channel_butserv(chptr, &me, ":%s TOPIC %s :%s",
+                                         sptr->servptr->name, chptr->chname, chptr->topic);
+              else
+                sendto_channel_butserv(chptr, &me, ":%s TOPIC %s :%s", 
+                                       sptr->name, chptr->chname, chptr->topic);
             }
           else
-            sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
-                       me.name, parv[0], chptr->chname);
+            {           
+              sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
+                         me.name, parv[0], chptr->chname);
+              return 0;
+            }
+          
+
         }
       else  /* only asking  for topic  */
         {
@@ -3882,6 +4305,10 @@
                  me.name, parv[0], name);
     }
 
+  if(enforced)
+     sendto_realops("Enforced topic on %s from %s (%s@%s)",
+                    chptr->chname, sptr->name, sptr->username, sptr->host);
+
   return 0;
 }
 
@@ -3899,6 +4326,7 @@
   struct Client *acptr;
   struct Channel *chptr;
   int need_invite=NO;
+  int enforced=0;
 
   if (parc < 3 || *parv[1] == '\0')
     {
@@ -3956,9 +4384,13 @@
       return 0;
     }
 
+  enforced = !is_chan_op(sptr, chptr) && chptr &&
+             (chptr->mode.mode & MODE_INVITEONLY) &&
+             (IsEnforce(sptr) || IsServer(cptr));
+
   /* By this point, chptr is non NULL */  
 
-  if (!IsMember(sptr, chptr))
+  if (!IsMember(sptr, chptr) && !enforced)
     {
       if (MyClient(sptr))
         sendto_one(sptr, form_str(ERR_NOTONCHANNEL),
@@ -3978,15 +4410,14 @@
     {
       need_invite = YES;
 
-      if (!is_chan_op(sptr, chptr))
-        {
-          if (MyClient(sptr))
-            sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
-                       me.name, parv[0], parv[2]);
-          return -1;
-        }
-    }
-
+      if (!is_chan_op(sptr, chptr) && !enforced)
+      {
+        if (MyClient(sptr))
+          sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
+                     me.name, parv[0], parv[2]);
+        return -1;
+     }
+  }
   /*
    * due to some whining I've taken out the need for the channel
    * being +i before sending an INVITE. It was intentionally done this
@@ -4042,8 +4473,28 @@
   if(MyConnect(acptr) && need_invite)
     add_invite(acptr, chptr);
 
-  sendto_prefix_one(acptr, sptr, ":%s INVITE %s :%s",
-                    parv[0], acptr->name, parv[2]);
+  if(enforced)
+  {
+    sendto_realops("Enforced invite for %s on %s from %s (%s@%s)",
+                   acptr->name, chptr->chname, sptr->name, sptr->username, sptr->host);
+
+    if(MyClient(acptr))
+    {
+      if(IsServer(cptr))
+        sendto_prefix_one(acptr, sptr, ":%s INVITE %s :%s",
+                          sptr->servptr->name, acptr->name, parv[2]);
+      else
+        sendto_prefix_one(acptr, sptr, ":%s INVITE %s :%s",
+                          me.name, acptr->name, parv[2]);
+    }
+    else
+      sendto_prefix_one(acptr, sptr, ":%s INVITE %s :%s",
+                        parv[0], acptr->name, parv[2]);
+  }
+  else
+    sendto_prefix_one(acptr, sptr, ":%s INVITE %s :%s",
+                      parv[0], acptr->name, parv[2]);
+      
   return 0;
 }
 
@@ -4175,7 +4626,12 @@
 	  if(is_chan_op(sptr,chptr))
 #endif
 	    {
-	      if (lp->flags & CHFL_CHANOP)
+              if(IsEnforce(c2ptr))
+                {
+                  strcat(buf, "!");
+                  idx++;
+                }              
+	      else if (lp->flags & CHFL_CHANOP)
 		{
 		  strcat(buf, "@");
 		  idx++;
@@ -4184,7 +4640,7 @@
 		{
 		  strcat(buf, "+");
 		  idx++;
-		}
+		}              
 	    }
           strncat(buf, c2ptr->name, NICKLEN);
           idx += strlen(c2ptr->name) + 1;
@@ -4228,6 +4684,7 @@
 
       if (!IsPerson(c2ptr) || IsInvisible(c2ptr))
         continue;
+
       lp = c2ptr->user->channel;
       /*
        * dont show a client if they are on a secret channel or
@@ -4513,7 +4970,7 @@
       if (doesop && !haveops)
         {
           chptr->channelts = tstosend = newts;
-#if 0
+
           /* Only warn of Hacked ops if the channel already
            * existed on this side.
            * This should drop the number of warnings down dramatically
@@ -4525,8 +4982,7 @@
                              sptr->name,
                              chptr->chname);
             }
-#endif
-        }
+       }
       else
         tstosend = oldts;
     }
@@ -4850,6 +5306,40 @@
       people++;
       if (!IsMember(acptr, chptr))
         {
+#ifdef HAVE_SSL
+          if(IsSSLChannel(chptr) && !IsSSLUmode(acptr))
+            {
+              if(IsSSLOnlyChannel(chptr))
+                {
+                  char message[NICKLEN+CHANNELLEN+HOSTLEN+60];
+                  
+                  /* something unexpected happened */
+                  ircsprintf(message, "WARNING: SJOIN from %s for channel %s by %s breaks SSL only mode.",
+                             cptr->name, parv[2], s);
+                  
+                  sendto_realops(message);
+                  sendto_channel_type_notice(cptr, chptr, MODE_CHANOP, message);                  
+                                 
+                  ClearSSLOnlyChannel(chptr);
+                  ClearSSLChannel(chptr);
+                  sendto_channel_butserv(chptr, sptr, ":%s MODE %s -xz",
+                                         me.name, chptr->chname);
+                  sendto_match_servs(chptr, sptr, ":%s MODE %s -xz",
+                                     me.name, chptr->chname);
+                }
+              else
+                {                  
+                  sendto_realops_flags(FLAGS_DEBUG, "SJOIN from %s for channel %s by %s breaks SSL mode.",
+                                       cptr->name, parv[2], s);
+              
+                  ClearSSLChannel(chptr);
+                  sendto_channel_butserv(chptr, sptr, ":%s MODE %s -z",
+                                         me.name, chptr->chname);
+                  sendto_match_servs(chptr, sptr, ":%s MODE %s -z",
+                                     me.name, chptr->chname);
+                }
+            }
+#endif      
           add_user_to_channel(chptr, acptr, fl);
           sendto_channel_butserv(chptr, acptr, ":%s JOIN :%s",
                                  s, parv[2]);
diff -uNrd ircd-hybrid-6.0/src/class.c ircd-pi1.0a/src/class.c
--- ircd-hybrid-6.0/src/class.c	Mon Jan 31 19:44:11 2000
+++ ircd-pi1.0a/src/class.c	Fri Nov  2 19:23:27 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: class.c,v 1.14 2000/02/01 00:44:11 lusky Exp $
+ *   $Id: class.c,v 1.1.1.1 2001/11/03 00:23:27 shifty Exp $
  */
 #include "class.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/client.c ircd-pi1.0a/src/client.c
--- ircd-hybrid-6.0/src/client.c	Sat Dec 30 19:11:59 2000
+++ ircd-pi1.0a/src/client.c	Tue May 14 00:03:35 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: client.c,v 1.58 2000/12/31 00:11:59 lusky Exp $
+ *  $Id: client.c,v 1.8 2002/05/14 04:03:35 smoli Exp $
  */
 #include "client.h"
 #include "class.h"
@@ -45,6 +45,7 @@
 #include "struct.h"
 #include "whowas.h"
 #include "s_debug.h"
+#include "config.h"
 
 #include <assert.h>
 #include <fcntl.h>
@@ -181,8 +182,10 @@
 #ifdef FLUD
   cptr->fludees = NULL;
 #endif
+#ifdef HAVE_SSL
+  cptr->ssl     = NULL;
+#endif
 #endif /* NULL_POINTER_NOT_ZERO */
-
   return cptr;
 }
 
@@ -520,6 +523,9 @@
                 {
                   sendto_ops("No response from %s, closing link",
                              get_client_name(cptr, MASK_IP));
+#ifdef BACKUP
+                  backup_lost_link(cptr);
+#endif /* BACKUP */
                 }
               /*
                * this is used for KILL lines with time restrictions
@@ -680,13 +686,20 @@
 #endif
     }
 
-  else if (IsClient(cptr)) {
-    --Count.total;
-    if (IsAnOper(cptr))
-      --Count.oper;
-    if (IsInvisible(cptr)) 
-      --Count.invisi;
-  }
+  else if(IsClient(cptr))
+    {      
+      --Count.total;
+      
+#ifdef HAVE_SSL
+      if(IsSSLUmode(cptr))
+        --Count.reach_ssl;
+#endif
+        
+      if (IsAnOper(cptr))
+        --Count.oper;
+      if (IsInvisible(cptr)) 
+        --Count.invisi;
+    }
 }
 
 static void release_client_state(struct Client* cptr)
@@ -1214,7 +1227,24 @@
                                    sptr->name, comment);
 
           while ((lp = sptr->user->channel))
-            remove_user_from_channel(sptr,lp->value.chptr,0);
+            {  
+              remove_user_from_channel(sptr,lp->value.chptr,0);
+#ifdef HAVE_SSL
+              if(!IsSSLChannel(lp->value.chptr) && is_ssl_channel(lp->value.chptr))
+                {
+                  sendto_realops_flags(FLAGS_DEBUG, "QUIT by %s puts channel %s into SSL mode.",
+                                       sptr->name, lp->value.chptr->chname);
+                  
+                  SetSSLChannel(lp->value.chptr);
+                  sendto_channel_butserv(lp->value.chptr, sptr,
+                                         ":%s MODE %s +z",
+                                         me.name, lp->value.chptr->chname);
+                  sendto_match_servs(lp->value.chptr, sptr,
+                                     ":%s MODE %s +z",
+                                     me.name, lp->value.chptr->chname);
+                }
+#endif
+            }
           
           /* Clean up invitefield */
           while ((lp = sptr->user->invited))
@@ -1432,7 +1462,10 @@
       if (IsClient(sptr))
         {
           Count.local--;
-
+#ifdef HAVE_SSL          
+          if(IsSSL(sptr))
+            Count.local_ssl--;
+#endif
           /* LINKLIST */
           /* oh for in-line functions... */
           if(IsPerson(sptr))        /* a little extra paranoia */
@@ -1460,7 +1493,7 @@
         {
           Count.myserver--;
           fdlist_delete(sptr->fd, FDL_SERVER | FDL_BUSY);
-
+          
           /* LINKLIST */
           /* oh for in-line functions... */
           {
@@ -1539,7 +1572,7 @@
                             sptr->host,
                             sptr->sendK,
                             sptr->receiveK);
-                write(logfile, linebuf, strlen(linebuf));
+                write(logfile, linebuf, irclen(linebuf));
                 /*
                  * Resync the file evey 10 seconds
                  */
@@ -1603,10 +1636,13 @@
           sendto_ops("%s was connected for %d seconds.  %d/%d sendK/recvK.",
                      sptr->name, CurrentTime - sptr->firsttime,
                      sptr->sendK, sptr->receiveK);
+
           log(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
               sptr->name, CurrentTime - sptr->firsttime, 
               sptr->sendK, sptr->receiveK);
-
+#ifdef BACKUP
+          backup_lost_link(sptr);
+#endif /* BACKUP */
               /* Just for paranoia... this shouldn't be necessary if the
               ** remove_dependents() stuff works, but it's still good
               ** to do it.    MyConnect(sptr) has been set to false,
diff -uNrd ircd-hybrid-6.0/src/dbuf.c ircd-pi1.0a/src/dbuf.c
--- ircd-hybrid-6.0/src/dbuf.c	Thu Dec 23 02:10:54 1999
+++ ircd-pi1.0a/src/dbuf.c	Sun May  5 00:42:24 2002
@@ -21,7 +21,7 @@
  * see the header file (dbuf.h).
  *
  *
- * $Id: dbuf.c,v 1.16 1999/12/23 07:10:54 lusky Exp $
+ * $Id: dbuf.c,v 1.6 2002/05/05 04:42:24 smoli Exp $
  */
 #include "dbuf.h"
 #include "common.h"
@@ -31,7 +31,7 @@
 #include <assert.h>
 #include <stdio.h>
 #include <stdlib.h>
-
+#include <string.h>
 
 /*
  * And this 'DBufBuffer' should never be referenced outside the
